IO::IOHandlerCommon Class Referenceabstract

This class contains further functionality that makes it more convenient to derive from than IOHandlerImpl in most but not all cases. More...

`#include <IOHandlerCommon.h>`

Inheritance diagram for IO::IOHandlerCommon:

## Public Member Functions

| IOHandlerCommon (const char *formatName, const char *formatDescription)
void | readRing (Scanner &in, VarNames &names)
| Reads a ring, i.e.
bool | peekRing (Scanner &in)
| Returns true if what follows in the input is a ring, assuming there are no syntax errors.
void | readBareIdeal (Scanner &in, InputConsumer &consumer)
| Reads an ideal without a ring preceding it.
void | readBarePolynomial (Scanner &in, const VarNames &names, CoefBigTermConsumer &consumer)
| Reads a polynomial without a ring preceding it.
Public Member Functions inherited from IOHandler
virtual | ~IOHandler ()
void | readIdeal (Scanner &in, InputConsumer &consumer)
| Read an ideal and feed it to the consumer.
void | readIdeals (Scanner &in, InputConsumer &consumer)
| Read a number of ideals and feed them to the consumer.
void | readTerm (Scanner &in, const VarNames &names, vector< mpz_class > &term)
void | readPolynomial (Scanner &in, CoefBigTermConsumer &consumer)
void | readSatBinomIdeal (Scanner &in, SatBinomConsumer &consumer)
void | writeTerm (const vector< mpz_class > &term, const VarNames &names, FILE *out)
bool | hasMoreInput (Scanner &in) const
const char * | getName () const
const char * | getDescription () const
unique_ptr< BigTermConsumer > | createIdealWriter (FILE *out)
unique_ptr< BigTermConsumer > | createIdealListWriter (FILE *out)
unique_ptr< CoefBigTermConsumer > | createPolynomialWriter (FILE *out)
bool | supportsInput (const DataType &type) const
bool | supportsOutput (const DataType &type) const

## Private Member Functions

virtual void | doReadIdeal (Scanner &in, InputConsumer &consumer)
virtual void | doReadIdeals (Scanner &in, InputConsumer &consumer)
virtual void | doReadPolynomial (Scanner &in, CoefBigTermConsumer &consumer)
virtual void | doReadRing (Scanner &in, VarNames &names)=0
virtual bool | doPeekRing (Scanner &in)=0
virtual void | doReadBareIdeal (Scanner &in, InputConsumer &consumer)
virtual void | doReadBarePolynomial (Scanner &in, const VarNames &names, CoefBigTermConsumer &consumer)

## Additional Inherited Members

Protected Member Functions inherited from IO::IOHandlerImpl
| IOHandlerImpl (const char *formatName, const char *formatDescription)
void | registerInput (const DataType &type)
| Specify that input of the argument type is supported.
void | registerOutput (const DataType &type)
| Specify that output of the argument type is supported.

## Detailed Description

This class contains further functionality that makes it more convenient to derive from than IOHandlerImpl in most but not all cases.

Definition at line 33 of file IOHandlerCommon.h.

## Constructor & Destructor Documentation

## IOHandlerCommon()

IO::IOHandlerCommon::IOHandlerCommon | ( | const char * | formatName,
|  | const char * | formatDescription )

Definition at line 27 of file IOHandlerCommon.cpp.

## Member Function Documentation

## doPeekRing()

virtual bool IO::IOHandlerCommon::doPeekRing | ( | Scanner & | in | ) |

private pure virtual

Implemented in IO::CoCoA4IOHandler, IO::Macaulay2IOHandler, IO::MonosIOHandler, and IO::SingularIOHandler.

## doReadBareIdeal()

void IO::IOHandlerCommon::doReadBareIdeal | ( | Scanner & | in,
|  | InputConsumer & | consumer )

private virtual

Reimplemented in IO::CoCoA4IOHandler, IO::Macaulay2IOHandler, IO::MonosIOHandler, and IO::SingularIOHandler.

Definition at line 87 of file IOHandlerCommon.cpp.

## doReadBarePolynomial()

void IO::IOHandlerCommon::doReadBarePolynomial | ( | Scanner & | in,
|  | const VarNames & | names,
|  | CoefBigTermConsumer & | consumer )

private virtual

Reimplemented in IO::CoCoA4IOHandler, IO::Macaulay2IOHandler, and IO::SingularIOHandler.

Definition at line 81 of file IOHandlerCommon.cpp.

## doReadIdeal()

void IO::IOHandlerCommon::doReadIdeal | ( | Scanner & | in,
|  | InputConsumer & | consumer )

private virtual

Reimplemented from IO::IOHandlerImpl.

Definition at line 50 of file IOHandlerCommon.cpp.

## doReadIdeals()

void IO::IOHandlerCommon::doReadIdeals | ( | Scanner & | in,
|  | InputConsumer & | consumer )

private virtual

Reimplemented from IO::IOHandlerImpl.

Definition at line 57 of file IOHandlerCommon.cpp.

## doReadPolynomial()

void IO::IOHandlerCommon::doReadPolynomial | ( | Scanner & | in,
|  | CoefBigTermConsumer & | consumer )

private virtual

Reimplemented from IO::IOHandlerImpl.

Definition at line 74 of file IOHandlerCommon.cpp.

## doReadRing()

virtual void IO::IOHandlerCommon::doReadRing | ( | Scanner & | in,
|  | VarNames & | names )

private pure virtual

Implemented in IO::CoCoA4IOHandler, IO::Macaulay2IOHandler, IO::MonosIOHandler, and IO::SingularIOHandler.

## peekRing()

bool IO::IOHandlerCommon::peekRing | ( | Scanner & | in | ) |

Returns true if what follows in the input is a ring, assuming there are no syntax errors.

Definition at line 36 of file IOHandlerCommon.cpp.

## readBareIdeal()

void IO::IOHandlerCommon::readBareIdeal | ( | Scanner & | in,
|  | InputConsumer & | consumer )

Reads an ideal without a ring preceding it.

Definition at line 40 of file IOHandlerCommon.cpp.

## readBarePolynomial()

void IO::IOHandlerCommon::readBarePolynomial | ( | Scanner & | in,
|  | const VarNames & | names,
|  | CoefBigTermConsumer & | consumer )

Reads a polynomial without a ring preceding it.

Definition at line 44 of file IOHandlerCommon.cpp.

## readRing()

void IO::IOHandlerCommon::readRing | ( | Scanner & | in,
|  | VarNames & | names )

Reads a ring, i.e.

the names of the variables.

Definition at line 32 of file IOHandlerCommon.cpp.

The documentation for this class was generated from the following files:

- src/IOHandlerCommon.h
- src/IOHandlerCommon.cpp